package com.steerinfo.dil.mapper;

import com.steerinfo.dil.model.WmshGridMaterial;
import com.steerinfo.framework.mapper.IBaseMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

@Mapper
public interface WmshGridMaterialMapper extends IBaseMapper<WmshGridMaterial, BigDecimal> {

    /**
     * 展示下游港口库存
     * @param mapVal
     * @return
     */
    List<Map<String,Object>> getUnloadPortStockList(Map<String, Object> mapVal);

    /**
     * 展示万州港库存
     * @param mapVal
     * @return
     */
    List<Map<String,Object>> getLoadPortStockList(Map<String, Object> mapVal);

    /**
     * 修改实时库存
     * @param wmshGridMaterial
     * @return
     */
    int updateByPrimaryKeySelective(WmshGridMaterial wmshGridMaterial);

    /**
     * 新增实时库存
     * @param wmshGridMaterial
     * @return
     */
    int insertSelective(WmshGridMaterial wmshGridMaterial);

    @Select("select seq_wmsh_grid_material.nextval from dual")
    BigDecimal selectMaxId();

   List<Map<String,Object>> getGridId(Map<String,Object> map);

    List<Map<String, Object>> getLoadPortStockByMaterialName(Map<String, Object> mapVal);

    List<Map<String, Object>> getUnLockPortStock(Map<String, Object> mapVal);
}