package com.steerinfo.dil.model;

import com.steerinfo.framework.model.IBasePO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.math.BigDecimal;
import java.util.Date;

@ApiModel(value="原料港存库实时库存")
public class WmshGridMaterial implements IBasePO<BigDecimal> {
    /**
     * 主键ID(GM_ID,DECIMAL,38)
     */
    @ApiModelProperty(value="主键ID",required=true)
    private BigDecimal gmId;

    /**
     * 港口ID(PORT_ID,DECIMAL,38)
     */
    @ApiModelProperty(value="港口ID",required=false)
    private BigDecimal portId;

    /**
     * 批次ID(BATCH_ID,DECIMAL,38)
     */
    @ApiModelProperty(value="批次ID",required=false)
    private BigDecimal batchId;

    /**
     * 物资吨位(GM_TONNAGE,DECIMAL,0)
     */
    @ApiModelProperty(value="物资吨位",required=false)
    private BigDecimal gmTonnage;

    /**
     * 记录创建人(INSERT_USERNAME,VARCHAR,20)
     */
    @ApiModelProperty(value="记录创建人",required=false)
    private String insertUsername;

    /**
     * 记录创建时间(INSERT_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="记录创建时间",required=false)
    private Date insertTime;

    /**
     * 记录修改人(UPDATE_USERNAME,VARCHAR,20)
     */
    @ApiModelProperty(value="记录修改人",required=false)
    private String updateUsername;

    /**
     * 记录修改时间(UPDATE_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="记录修改时间",required=false)
    private Date updateTime;

    /**
     * 记录创建或修改备注(INSERT_UPDATE_REMARK,VARCHAR,100)
     */
    @ApiModelProperty(value="记录创建或修改备注",required=false)
    private String insertUpdateRemark;

    /**
     * 逻辑删除0 没删除 1删除(DELETED,DECIMAL,38)
     */
    @ApiModelProperty(value="逻辑删除0 没删除 1删除",required=false)
    private BigDecimal deleted;

    private static final long serialVersionUID = 1L;

    @Override
    public BigDecimal getId() {
        return this.gmId;
    }

    @Override
    public void setId(BigDecimal gmId) {
        this.gmId = gmId;
    }

    public BigDecimal getGmId() {
        return gmId;
    }

    public void setGmId(BigDecimal gmId) {
        this.gmId = gmId;
    }

    public BigDecimal getPortId() {
        return portId;
    }

    public void setPortId(BigDecimal portId) {
        this.portId = portId;
    }

    public BigDecimal getBatchId() {
        return batchId;
    }

    public void setBatchId(BigDecimal batchId) {
        this.batchId = batchId;
    }

    public BigDecimal getGmTonnage() {
        return gmTonnage;
    }

    public void setGmTonnage(BigDecimal gmTonnage) {
        this.gmTonnage = gmTonnage;
    }

    public String getInsertUsername() {
        return insertUsername;
    }

    public void setInsertUsername(String insertUsername) {
        this.insertUsername = insertUsername == null ? null : insertUsername.trim();
    }

    public Date getInsertTime() {
        return insertTime;
    }

    public void setInsertTime(Date insertTime) {
        this.insertTime = insertTime;
    }

    public String getUpdateUsername() {
        return updateUsername;
    }

    public void setUpdateUsername(String updateUsername) {
        this.updateUsername = updateUsername == null ? null : updateUsername.trim();
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public String getInsertUpdateRemark() {
        return insertUpdateRemark;
    }

    public void setInsertUpdateRemark(String insertUpdateRemark) {
        this.insertUpdateRemark = insertUpdateRemark == null ? null : insertUpdateRemark.trim();
    }

    public BigDecimal getDeleted() {
        return deleted;
    }

    public void setDeleted(BigDecimal deleted) {
        this.deleted = deleted;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", gmId=").append(gmId);
        sb.append(", portId=").append(portId);
        sb.append(", batchId=").append(batchId);
        sb.append(", gmTonnage=").append(gmTonnage);
        sb.append(", insertUsername=").append(insertUsername);
        sb.append(", insertTime=").append(insertTime);
        sb.append(", updateUsername=").append(updateUsername);
        sb.append(", updateTime=").append(updateTime);
        sb.append(", insertUpdateRemark=").append(insertUpdateRemark);
        sb.append(", deleted=").append(deleted);
        sb.append(", serialVersionUID=").append(serialVersionUID);
        sb.append("]");
        return sb.toString();
    }
}