package com.steerinfo.dil.service.impl;

import com.steerinfo.dil.mapper.WmshInboundResultMapper;
import com.steerinfo.dil.model.WmshInboundResult;
import com.steerinfo.dil.service.IWmshInboundResultService;
import com.steerinfo.dil.util.DataChange;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * WmshInboundResult服务实现：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-10-10 11:08
 * 类描述
 * 修订历史：
 * 日期：2021-10-10
 * 作者：generator
 * 参考：
 * 描述：WmshInboundResult服务实现
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@Service
//        (value = "wmshInboundResultService")
public class WmshInboundResultServiceImpl implements IWmshInboundResultService {

    @Autowired
    private WmshInboundResultMapper wmshInboundResultMapper;

    /**
     * 添加港存库 入库实绩
     * @param
     * @return
     */
    @Override
    public int addWarehousingResult(Map<String,Object> map) {
        //获取主键
        WmshInboundResult wmshInboundResult=new WmshInboundResult();
        Integer id = wmshInboundResultMapper.getResultId();
        wmshInboundResult.setResultId(new BigDecimal(id));
        //生成入库编号
        String rkNum = DataChange.generateEightDigitsNumber("GRKD", id);
        wmshInboundResult.setResultNumber(rkNum);
        wmshInboundResult.setBatchId(DataChange.dataToBigDecimal(map.get("batchId")));
        wmshInboundResult.setPortId(DataChange.dataToBigDecimal(map.get("portId")));
        wmshInboundResult.setResultMaterialNumber(DataChange.dataToBigDecimal(map.get("resultMaterialNumber")));
        //生成入库日期 与 操作人员
        wmshInboundResult.setInsertTime(new Date());
        wmshInboundResult.setInsertUsername("admin");
        wmshInboundResult.setDeleted(new BigDecimal(0)); //状态 0 正常
        return wmshInboundResultMapper.insertSelective(wmshInboundResult);
    }

    /**
     * 查询所有港存库入库实绩
     * @param map
     * @return
     */
    @Override
    public List<Map<String, Object>> getAllResult(Map<String, Object> map) {
        return wmshInboundResultMapper.getAllResult(map);
    }

    /**
     * 通过Id查询实绩
     * @param resultId
     * @return
     */
    @Override
    public List<Map<String, Object>> getResultById(Integer resultId) {
        return wmshInboundResultMapper.getResultById(resultId);
    }

    /**
     * 修改港存库入库实绩
     * @param wmshInboundResult
     * @return
     */
    @Override
    public int updateWareHosingResult(WmshInboundResult wmshInboundResult) {
        return wmshInboundResultMapper.updateByPrimaryKeySelective(wmshInboundResult);
    }

    /**
     * 逻辑删除港存库入库实绩
     * @param ResultId
     * @return
     */
    @Override
    public int deleteWareHosingResult(Integer ResultId) {
        WmshInboundResult wmshInboundResult = new WmshInboundResult();
        wmshInboundResult.setResultId(new BigDecimal(ResultId));
        wmshInboundResult.setDeleted(new BigDecimal(1));
        return wmshInboundResultMapper.updateByPrimaryKeySelective(wmshInboundResult);
    }


}
